"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.NodeRepository = void 0;
const utils_js_1 = require("../utils.js");
/**
 * stores an instance of  `ObjectTypeDefinitionNode` or `InputObjectTypeDefinitionNode` using the node name as the key
 * and returns that node when replacing placeholders
 * */
class NodeRepository {
    constructor() {
        this._store = {};
    }
    get(key) {
        return this._store[key];
    }
    register(node) {
        if (!(0, utils_js_1.nodeIsObjectType)(node)) {
            throw new Error('Node is not an ObjectTypeDefinitionNode or InputObjectTypeDefinitionNode');
        }
        this._store[node.name.value] = node;
        return node;
    }
}
exports.NodeRepository = NodeRepository;
//#endregion
