import { nodeIsObjectType } from '../utils.js';
/**
 * stores an instance of  `ObjectTypeDefinitionNode` or `InputObjectTypeDefinitionNode` using the node name as the key
 * and returns that node when replacing placeholders
 * */
export class NodeRepository {
    constructor() {
        this._store = {};
    }
    get(key) {
        return this._store[key];
    }
    register(node) {
        if (!nodeIsObjectType(node)) {
            throw new Error('Node is not an ObjectTypeDefinitionNode or InputObjectTypeDefinitionNode');
        }
        this._store[node.name.value] = node;
        return node;
    }
}
//#endregion
